/* glkern.f -- translated by f2c (version 20041007).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Table of constant values */

 integer c__9 = 9;
 integer c__1 = 1;
 integer c__3 = 3;
 doublereal c_b70 = -.2;
 integer c__0 = 0;
 integer c__2 = 2;
 integer c_n1 = -1;

/* Subroutine */ int glkern_(doublereal *t, doublereal *x, integer *n, 
	doublereal *tt, integer *m, integer *ihom, integer *nue, integer *
	kord, integer *irnd, integer *ismo, integer *m1, doublereal *tu, 
	doublereal *to, doublereal *s, doublereal *sig, doublereal *wn, 
	doublereal *w1, doublereal *b, doublereal *y)
{
    /* Initialized data */

     doublereal bias[6]	/* was [2][3] */ = { .2,.04762,.4286,.1515,
	    1.33,.6293 };
     doublereal vark[6]	/* was [2][3] */ = { .6,1.25,2.143,11.93,35.,
	    381.6 };
     doublereal fak2[3] = { 4.,36.,576. };

    /* System generated locals */
    integer wn_dim1, wn_offset, w1_dim1, w1_offset, i__1, i__2;
    doublereal d__1, d__2, d__3;

    /* Builtin functions */
    integer s_wsle(cilist *), do_lio(integer *, integer *, char *, ftnlen), 
	    e_wsle(void);
    /* Subroutine */ int s_stop(char *, ftnlen);
    double pow_dd(doublereal *, doublereal *);

    /* Local variables */
     integer i__, j;
     doublereal q, b2, s0, r2;
     integer ii;
     doublereal bs;
     integer kk, io, nn;
     doublereal ex;
     integer iu;
     doublereal vi;
     integer it;
     doublereal sn, xi;
     integer kk2;
     doublereal fac;
     integer iiu, nyg;
     doublereal ssi, exs, too, snr, tuu, xmy2;
    extern /* Subroutine */ int coff_(doublereal *, integer *, doublereal *);
     doublereal bmin, bmax, bres, rvar, alpha, const__, exsvi;
     integer isort, itende;
    extern /* Subroutine */ int kernel_(doublereal *, doublereal *, integer *,
	     doublereal *, integer *, integer *, integer *, doublereal *, 
	    doublereal *, integer *, doublereal *);
     integer iprint;
    extern /* Subroutine */ int resest_(doublereal *, doublereal *, integer *,
	     doublereal *, doublereal *, doublereal *);
     integer inputs;

    /* Fortran I/O blocks */
     cilist io___7 = { 0, 6, 0, 0, 0 };
     cilist io___8 = { 0, 6, 0, 0, 0 };
     cilist io___9 = { 0, 6, 0, 0, 0 };
     cilist io___10 = { 0, 6, 0, 0, 0 };
     cilist io___11 = { 0, 6, 0, 0, 0 };
     cilist io___13 = { 0, 6, 0, 0, 0 };
     cilist io___14 = { 0, 6, 0, 0, 0 };
     cilist io___15 = { 0, 6, 0, 0, 0 };
     cilist io___16 = { 0, 6, 0, 0, 0 };
     cilist io___22 = { 0, 6, 0, 0, 0 };
     cilist io___23 = { 0, 6, 0, 0, 0 };
     cilist io___24 = { 0, 6, 0, 0, 0 };
     cilist io___25 = { 0, 6, 0, 0, 0 };
     cilist io___26 = { 0, 6, 0, 0, 0 };
     cilist io___27 = { 0, 6, 0, 0, 0 };


/* ----------------------------------------------------------------------* */
/* ----------------------------------------------------------------------- */
/*       SHORT-VERSION: August, 1996 */

/*       PURPOSE: */

/*       GENERAL SUBROUTINE FOR KERNEL SMOOTHING: */
/*       COMPUTATION OF ITERATIVE PLUG-IN ALGORITHM FOR GLOBAL BANDWIDTH */
/*       SELECTION FOR KERNELS WITH (NUE,KORD) = (0,2),(0,4),(1,3) OR */
/*       (2,4). */

/*  PARAMETERS : */

/*  INPUT    T(N)         INPUT GRID (T(1)<T(2)<...<T(N)) */
/*  INPUT    X(N)         DATA */
/*  INPUT    N            LENGTH OF X */
/*  INPUT    TT(M)        OUTPUT GRID */
/*  INPUT    M            LENGTH OF TT */
/*  INPUT    IHOM         HOMOSZEDASTICY OF VARIANCE */
/*                        0: HOMOSZEDASTIC ERROR VARIABLES, ELSE <> 0 */
/*                        ****** DEFAULT VALUE: IHOM=0 */
/*  INPUT    NUE          ORDER OF DERIVATIVE (0-4) */
/*                        ****** DEFAULT VALUE: NUE=0 */
/*  INPUT    KORD         ORDER OF KERNEL (<=6), FOR ISMO=0  ONLY */
/*                        NUE=0, KORD=2 OR KORD=4 */
/*                        OR NUE=1, KORD=3 OR NUE=2, KORD=4 ARE ALLOWED */
/*                        ****** DEFAULT VALUE: KORD=NUE+2 */
/*  INPUT    IRND         0: IF RANDOM GRID POINTS T MAY OCCUR */
/*                        <>0 ELSE  (ONLY NECESSARY IF S SHOULD BE */
/*                            COMPUTED) */
/*                        ****** DEFAULT VALUE IRND=0 */
/*  INPUT    ISMO         0:ESTIMATING THE OPTIMAL GLOBAL BANDWIDTH */
/*                        <>0 USING GLOBAL INPUT BANDWIDTH B */
/*                        ****** DEFAULT VALUE ISMO=0 */
/*  INPUT    M1           >=10, LENGTH OF W1, LARGE VALUES WILL INCREASE */
/*                        THE ACCURACY OF THE INTEGRAL APPROXIMATION */
/*                        ****** DEFAULT VALUE: M1=400 */
/* CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC */
/* IN/OUTPUT TU/TO        LOWER/UPPER BOUND FOR INTEGRAL APPROXIMATION */
/*                        AND VARIANCE ESTIMATION (IF SIG=0 AND IHOM=0), */
/*                        IF TO<=TU, [TU,TO] ARE COMPUTED AS ABOUT */
/*                        THE 87% MIDDLE PART OF [T(1),T(N)] */
/*                        ****** DEFAULT VALUES: TU=1.0, TO=0.0 */
/* IN/OUTPUT S(0:N)       IF S(N)<=S(0) THIS ARRAY IS COMPUTED AS */
/*                        MIDPOINTS OF T, FOR NON-RANDOM DESIGN AND AS */
/*                        SMOOTHED QUANTILES FOR RANDOM DESIGN */
/*                        ****** DEFAULT VALUES: S(0)=1.0, S(N)=0.0 */
/*                               AND THE OTHER S(I) CAN BE UNDEFINED */
/* IN/OUTPUT SIG          RESIDUAL VARIANCE, ESTIMATED FOR SIG=0 OR */
/*                        IHOM<>0, ELSE GIVEN BY INPUT */
/*                        ****** DEFAULT VALUE: SIG=-1.0 */
/* IN/OUTPUT B            GLOBAL PLUG-IN BANDWIDTH */
/*                        ****** B CAN BE UNDIFINED IF ISMO=0 */

/* WORK     WN(0:N,5)     WORK ARRAY FOR KERNEL SMOOTHING ROUTINE */
/*                        OR NUE=1, KORD=3 OR NUE=2, KORD=4 ARE ALLOWED */
/*                        ****** WILL BE SET IN SUBROUTINE */
/* WORK     W1(M1,3)      WORK ARRAY FOR INTEGRAL APPROXIMATION */
/*                        ****** WILL BE SET IN SUBROUTINE */

/* CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC */
/* OUTPUT   Y(M)          KERNEL ESTIMATE WITH BOP(=B0 FOR ISMO<>0) */
/*                        ****** WILL BE SET IN SUBROUTINE */
/* ----------------------------------------------------------------------- */
/*  USED SUBROUTINES: COFF, RESEST, KERNEL WITH FURTHER SUBROUTINES */

/* ----------------------------------------------------------------------- */
/* - */
/* -------- 1. INITIALISATIONS AND SOME ERROR-CHECKS */
    /* Parameter adjustments */
    wn_dim1 = *n - 0 + 1;
    wn_offset = 0 + wn_dim1;
    wn -= wn_offset;
    --x;
    --t;
    --y;
    --tt;
    w1_dim1 = *m1;
    w1_offset = 1 + w1_dim1;
    w1 -= w1_offset;

    /* Function Body */
    nyg = 0;
    inputs = 0;
/* -------- IF NO ERRORS SHOULD BE WRITTEN ON STANDARD OUTPUT, SET IPRINT=1 */
    iprint = 0;

    if (*nue > 4 || *nue < 0) {
	if (iprint == 0) {
	    s_wsle(&io___7);
	    do_lio(&c__9, &c__1, "glkern: Order of derivative not allowed", (
		    ftnlen)39);
	    e_wsle();
	}
	s_stop("", (ftnlen)0);
    }
    if (*nue > 2 && *ismo == 0) {
	if (iprint == 0) {
	    s_wsle(&io___8);
	    do_lio(&c__9, &c__1, "glkern: Order of derivative not allowed", (
		    ftnlen)39);
	    e_wsle();
	}
	s_stop("", (ftnlen)0);
    }
    if (*n <= 2) {
	if (iprint == 0) {
	    s_wsle(&io___9);
	    do_lio(&c__9, &c__1, "glkern: Number of data too small", (ftnlen)
		    32);
	    e_wsle();
	}
	s_stop("", (ftnlen)0);
    }
    if (*m < 1) {
	if (iprint == 0) {
	    s_wsle(&io___10);
	    do_lio(&c__9, &c__1, "glkern: No output points", (ftnlen)24);
	    e_wsle();
	}
	s_stop("", (ftnlen)0);
    }
    if (*m1 < 10) {
	if (iprint == 0) {
	    s_wsle(&io___11);
	    do_lio(&c__9, &c__1, "glkern: Variable M1 is choosen too small", (
		    ftnlen)40);
	    e_wsle();
	}
	s_stop("", (ftnlen)0);
    }
    kk = (*kord - *nue) / 2;
    if ((kk << 1) + *nue != *kord) {
	if (iprint == 0) {
	    s_wsle(&io___13);
	    do_lio(&c__9, &c__1, "glkern: Kernel order not allowed, set to ", 
		    (ftnlen)41);
	    i__1 = *nue + 2;
	    do_lio(&c__3, &c__1, (char *)&i__1, (ftnlen)sizeof(integer));
	    e_wsle();
	}
	*kord = *nue + 2;
    }
    if (*kord > 4 && *ismo == 0) {
	if (iprint == 0) {
	    s_wsle(&io___14);
	    do_lio(&c__9, &c__1, "glkern: Kernel order not allowed, set to ", 
		    (ftnlen)41);
	    i__1 = *nue + 2;
	    do_lio(&c__3, &c__1, (char *)&i__1, (ftnlen)sizeof(integer));
	    e_wsle();
	}
	*kord = *nue + 2;
    }
    if (*kord > 6 || *kord <= *nue) {
	if (iprint == 0) {
	    s_wsle(&io___15);
	    do_lio(&c__9, &c__1, "glkern: Kernel order not allowed, set to ", 
		    (ftnlen)41);
	    i__1 = *nue + 2;
	    do_lio(&c__3, &c__1, (char *)&i__1, (ftnlen)sizeof(integer));
	    e_wsle();
	}
	*kord = *nue + 2;
    }
    if (*ismo != 0 && *b <= 0.) {
	if (iprint == 0) {
	    s_wsle(&io___16);
	    do_lio(&c__9, &c__1, "glkern: Plug-in bandwidth is used", (ftnlen)
		    33);
	    e_wsle();
	}
	*ismo = 0;
    }
/* - */
/* -------- 2. COMPUTATION OF S-SEQUENCE */
    s0 = t[1] * 1.5f - t[2] * .5f;
    sn = t[*n] * 1.5f - t[*n - 1] * .5f;
    if (s[*n] <= s[0]) {
	inputs = 1;
	i__1 = *n - 1;
	for (i__ = 1; i__ <= i__1; ++i__) {
/* L20: */
	    s[i__] = (t[i__] + t[i__ + 1]) * .5f;
	}
	s[0] = s0;
	s[*n] = sn;
	if (*ismo != 0 && *irnd != 0) {
	    goto L160;
	}
    } else {
	if (*ismo != 0) {
	    goto L160;
	}
    }
/* - */
/* -------- 3. COMPUTATION OF MINIMAL, MAXIMAL ALLOWED BANDWIDTH */
    bmax = (sn - s0) * .5f;
    bmin = (sn - s0) / (doublereal) (*n) * (doublereal) (*kord - 1) * .6f;
/* - */
/* -------- 4. WARNINGS IF TT-GRID LARGER THAN T-GRID */
    if (tt[1] < s0 && tt[*m] > sn && iprint == 0) {
	s_wsle(&io___22);
	do_lio(&c__9, &c__1, "glkern: Extrapolation at both boundaries not o"
		"ptimized", (ftnlen)54);
	e_wsle();
    }
    if (tt[1] < s0 && tt[*m] <= sn && iprint == 0) {
	s_wsle(&io___23);
	do_lio(&c__9, &c__1, "glkern: Extrapolation at left boundary not opt"
		"imized", (ftnlen)52);
	e_wsle();
    }
    if (tt[1] >= s0 && tt[*m] > sn && iprint == 0) {
	s_wsle(&io___24);
	do_lio(&c__9, &c__1, "glkern: Extrapolation at right boundary not op"
		"timized", (ftnlen)53);
	e_wsle();
    }
/* - */
/* -------- 5. COMPUTE TU,TO AND THEIR T-GRID AS INNER PART FOR */
/*            INTEGRAL APPROXIMATION IN THE ITERATIONS */
    if (*to <= *tu) {
	*tu = s0 * .933f + sn * .067f;
	*to = s0 * .067f + sn * .933f;
    }
    if (*tu < s0 && *to > sn && iprint == 0) {
	s_wsle(&io___25);
	do_lio(&c__9, &c__1, "glkern warning: Estimate functional outside bo"
		"undaries", (ftnlen)54);
	e_wsle();
    }
    if (*tu < s0 && *to <= sn && iprint == 0) {
	s_wsle(&io___26);
	do_lio(&c__9, &c__1, "glkern warning: Estimate functional outside le"
		"ft boundary", (ftnlen)57);
	e_wsle();
    }
    if (*tu >= s0 && *to > sn && iprint == 0) {
	s_wsle(&io___27);
	do_lio(&c__9, &c__1, "glkern warning: Estimate functional outside ri"
		"ght boundary", (ftnlen)58);
	e_wsle();
    }
    iu = 1;
    io = *n;
    wn[wn_dim1 + 1] = 0.f;
    wn[*n + wn_dim1] = 0.f;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (t[i__] <= *tu || t[i__] >= *to) {
	    wn[i__ + wn_dim1] = 0.f;
	}
	if (t[i__] > *tu && t[i__] < *to) {
	    wn[i__ + wn_dim1] = 1.f;
	}
	if (t[i__] < *tu) {
	    iu = i__ + 1;
	}
/* L50: */
	if (t[i__] <= *to) {
	    io = i__;
	}
    }
    nn = io - iu + 1;
/* - */
/* -------- 6. COMPUTE T-GRID FOR INTEGRAL APPROXIMATION */
    i__1 = *m1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	w1[i__ + (w1_dim1 << 1)] = 1.f;
/* L60: */
	w1[i__ + w1_dim1] = *tu + (*to - *tu) * (doublereal) (i__ - 1) / (
		doublereal) (*m1 - 1);
    }
/* - */
/* -------- 7. CALCULATION OF WEIGHT FUNCTION */
    alpha = .076923076923076927;
    i__1 = io;
    for (i__ = iu; i__ <= i__1; ++i__) {
	xi = (t[i__] - *tu) / alpha / (*to - *tu);
	if (xi > 1.) {
	    goto L71;
	}
/* L70: */
	wn[i__ + wn_dim1] = (10.f - xi * 15 + xi * 6 * xi) * xi * xi * xi;
    }
L71:
    i__1 = iu;
    for (i__ = io; i__ >= i__1; --i__) {
	xi = (*to - t[i__]) / alpha / (*to - *tu);
	if (xi > 1.) {
	    goto L73;
	}
/* L72: */
	wn[i__ + wn_dim1] = (10.f - xi * 15 + xi * 6 * xi) * xi * xi * xi;
    }
L73:
    i__1 = *m1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	xi = (w1[i__ + w1_dim1] - *tu) / alpha / (*to - *tu);
	if (xi > 1.) {
	    goto L75;
	}
/* L74: */
	w1[i__ + (w1_dim1 << 1)] = (10.f - xi * 15 + xi * 6 * xi) * xi * xi * 
		xi;
    }
L75:
    for (i__ = *m1; i__ >= 1; --i__) {
	xi = (*to - w1[i__ + w1_dim1]) / alpha / (*to - *tu);
	if (xi > 1.) {
	    goto L77;
	}
/* L76: */
	w1[i__ + (w1_dim1 << 1)] = (10.f - xi * 15 + xi * 6 * xi) * xi * xi * 
		xi;
    }
L77:
/* - */
/* -------- 8. COMPUTE CONSTANTS FOR ITERATION */
    ex = 1.f / (doublereal) (*kord + *kord + 1);
    kk2 = *kord - *nue;
    kk = kk2 / 2;
/* - */
/* -------- 9. ESTIMATING VARIANCE AND SMOOTHED PSEUDORESIDUALS */
    rvar = *sig;
    if (*sig <= 0.f && *ihom == 0) {
	resest_(&t[iu], &x[iu], &nn, &wn[iu + (wn_dim1 << 1)], &snr, sig);
    }
    if (*ihom != 0) {
	resest_(&t[1], &x[1], n, &wn[(wn_dim1 << 1) + 1], &snr, sig);
/* Computing MAX */
	d__3 = (doublereal) nn;
	d__1 = bmin, d__2 = pow_dd(&d__3, &c_b70) * .2f * (s[io] - s[iu - 1]);
	bres = max(d__1,d__2);
	i__1 = *n;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    wn[i__ + wn_dim1 * 3] = t[i__];
/* L91: */
	    wn[i__ + (wn_dim1 << 1)] *= wn[i__ + (wn_dim1 << 1)];
	}
	kernel_(&t[1], &wn[(wn_dim1 << 1) + 1], n, &bres, &c__0, &kk2, &nyg, 
		s, &wn[iu + wn_dim1 * 3], &nn, &wn[iu + (wn_dim1 << 2)]);
    } else {
	coff_(&wn[(wn_dim1 << 2) + 1], n, sig);
    }
/* - */
/* -------- 10. ESTIMATE/COMPUTE INTEGRAL CONSTANT */
L100:
    vi = 0.f;
    i__1 = io;
    for (i__ = iu; i__ <= i__1; ++i__) {
/* L101: */
/* Computing 2nd power */
	d__1 = s[i__] - s[i__ - 1];
	vi += wn[i__ + wn_dim1] * *n * (d__1 * d__1) * wn[i__ + (wn_dim1 << 2)
		];
    }
/* - */
/* -------- 11. REFINEMENT OF S-SEQUENCE FOR RANDOM DESIGN */
    if (inputs == 1 && *irnd == 0) {
	i__1 = *n;
	for (i__ = 0; i__ <= i__1; ++i__) {
	    wn[i__ + wn_dim1 * 5] = (doublereal) i__ / (doublereal) (*n + 1);
	    wn[i__ + (wn_dim1 << 1)] = ((doublereal) i__ + .5f) / (doublereal)
		     (*n + 1);
/* L110: */
	    wn[i__ + wn_dim1 * 3] = wn[i__ + (wn_dim1 << 1)];
	}
	exs = -((doublereal) (*kord * 3 + 1)) / (doublereal) (*kord * 6 + 3);
	exsvi = (doublereal) (*kord) / (doublereal) (*kord * 6 + 3);
	d__1 = vi / (sn - s0);
	d__2 = (doublereal) (*n);
	bs = pow_dd(&d__1, &exsvi) * .5f * pow_dd(&d__2, &exs);
	i__1 = *n + 1;
	kernel_(&wn[wn_dim1 * 5 + 1], &t[1], n, &bs, &c__0, &c__2, &nyg, &wn[
		wn_dim1 * 3], &wn[wn_dim1 * 2], &i__1, s);
	isort = 0;
	vi = 0.f;
L111:
	i__1 = *n;
	for (i__ = 1; i__ <= i__1; ++i__) {
/* Computing 2nd power */
	    d__1 = s[i__] - s[i__ - 1];
	    vi += wn[i__ + wn_dim1] * *n * (d__1 * d__1) * wn[i__ + (wn_dim1 
		    << 2)];
	    if (s[i__] < s[i__ - 1]) {
		ssi = s[i__ - 1];
		s[i__ - 1] = s[i__];
		s[i__] = ssi;
		isort = 1;
	    }
/* L112: */
	}
	if (isort == 1) {
	    goto L111;
	}
	if (*ismo != 0) {
	    goto L160;
	}
    }
    *b = bmin * 2.f;
/* - */
/* -------- 12. COMPUTE INFLATION CONSTANT AND EXPONENT AND LOOP OF ITERATIONS */
/* Computing 2nd power */
    d__1 = bias[kk + (*nue << 1) - 1];
    const__ = (doublereal) ((*nue << 1) + 1) * fak2[*kord - 2] * vark[kk + (*
	    nue << 1) - 1] * vi / ((doublereal) ((*kord << 1) - (*nue << 1)) *
	     (d__1 * d__1) * (doublereal) (*n));
    d__1 = (doublereal) (*n);
    d__2 = 2.f / (doublereal) (((*kord << 1) + 1) * ((*kord << 1) + 3));
    fac = (*nue / 10.f + 1.f + (*kord - *nue - 2.f) * .05f) * 1.1f * pow_dd(&
	    d__1, &d__2);
    itende = (*kord << 1) + 1 + *kord * ((*kord << 1) + 1);
    i__1 = itende;
    for (it = 1; it <= i__1; ++it) {
/* - */
/* -------- 13. ESTIMATE DERIVATIVE OF ORDER KORD IN ITERATIONS */
	b2 = *b * fac;
/* Computing MAX */
	d__1 = b2, d__2 = bmin / (doublereal) (*kord - 1) * (doublereal) (*
		kord + 1);
	b2 = max(d__1,d__2);
	b2 = min(b2,bmax);
	i__2 = *kord + 2;
	kernel_(&t[1], &x[1], n, &b2, kord, &i__2, &nyg, s, &w1[w1_dim1 + 1], 
		m1, &w1[w1_dim1 * 3 + 1]);
/* - */
/* -------- 14. ESTIMATE INTEGRALFUNCTIONAL IN ITERATIONS */
	xmy2 = (w1[(w1_dim1 << 1) + 1] * w1[w1_dim1 * 3 + 1] * w1[w1_dim1 * 3 
		+ 1] + w1[*m1 + (w1_dim1 << 1)] * w1[*m1 + w1_dim1 * 3] * w1[*
		m1 + w1_dim1 * 3]) * .75f;
	i__2 = *m1 - 1;
	for (i__ = 2; i__ <= i__2; ++i__) {
/* L140: */
	    xmy2 += w1[i__ + (w1_dim1 << 1)] * w1[i__ + w1_dim1 * 3] * w1[i__ 
		    + w1_dim1 * 3];
	}
	xmy2 = xmy2 * (*to - *tu) / (doublereal) (*m1);
/* - */
/* -------- 15. FINISH OF ITERATIONS */
	d__1 = const__ / xmy2;
	*b = pow_dd(&d__1, &ex);
	*b = max(bmin,*b);
	*b = min(bmax,*b);
/* L120: */
    }
/* - */
/* -------- 16  COMPUTE SMOOTHED FUNCTION WITH PLUG-IN BANDWIDTH */
L160:
    kernel_(&t[1], &x[1], n, b, nue, kord, &nyg, s, &tt[1], m, &y[1]);
/* - */
/* -------- 17. VARIANCE CHECK */
    if (rvar == *sig || snr < .88f || *ihom != 0 || *nue > 0) {
	return 0;
    }
    ii = 0;
    iiu = 0;
    j = 2;
    tuu = max(*tu,tt[1]);
/* Computing MIN */
    d__1 = *to, d__2 = tt[*m];
    too = min(d__1,d__2);
    i__1 = io;
    for (i__ = iu; i__ <= i__1; ++i__) {
	if (t[i__] < tuu || t[i__] > too) {
	    goto L170;
	}
	++ii;
	if (iiu == 0) {
	    iiu = i__;
	}
L171:
	if (tt[j] < t[i__]) {
	    ++j;
	    if (j <= *m) {
		goto L171;
	    }
	}
	wn[ii + wn_dim1 * 3] = x[i__] - y[j] + (y[j] - y[j - 1]) * (tt[j] - t[
		i__]) / (tt[j] - tt[j - 1]);
L170:
	;
    }
    resest_(&t[iiu], &wn[wn_dim1 * 3 + 1], &ii, &wn[(wn_dim1 << 2) + 1], &snr,
	     &rvar);
    q = *sig / rvar;
    if (q <= 2.f) {
	return 0;
    }
    if (q > 5.f && r2 > .95f) {
	rvar *= .5f;
    }
    *sig = rvar;
    coff_(&wn[(wn_dim1 << 2) + 1], n, sig);
    goto L100;
} /* glkern_ */

/* Subroutine */ int resest_(doublereal *t, doublereal *x, integer *n, 
	doublereal *res, doublereal *snr, doublereal *sigma2)
{
    /* System generated locals */
    integer i__1;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
     integer i__;
     doublereal g1, g2, dn, ex, tt, sx, ex2;

/* ----------------------------------------------------------------------- */
/*       VERSION: JUNE, 1996 */

/*       PURPOSE: */

/*       COMPUTES ONE-LEAVE-OUT RESIDUALS FOR NONPARAMETRIC ESTIMATION */
/*       OF RESIDUAL VARIANCE (LOCAL LINEAR APPROXIMATION FOLLOWED BY */
/*       REWEIGHTING) */

/*     PARAMETERS: */

/*     INPUT   T(N)      ABSCISSAE (ORDERED: T(I)<=T(I+1)) */
/*     INPUT   X(N)      DATA */
/*     INPUT   N         LENGTH OF DATA ( >2 ) */
/*     OUTPUT  RES(N)    RESIDUALS AT T(1),...,T(N) */
/*     OUTPUT  SNR       EXPLAINED VARIANCE OF THE TRUE CURVE */
/*     OUTPUT  SIGMA2    ESTIMATION OF SIGMA**2 (RESIDUAL VARIANCE) */

/* ----------------------------------------------------------------------- */
/* - */
    /* Parameter adjustments */
    --res;
    --x;
    --t;

    /* Function Body */
    *sigma2 = 0.f;
    ex = x[1] * (t[2] - t[1]);
    ex2 = x[1] * ex;
    i__1 = *n - 1;
    for (i__ = 2; i__ <= i__1; ++i__) {
	tt = t[i__ + 1] - t[i__ - 1];
	if (tt != 0.f) {
	    g1 = (t[i__ + 1] - t[i__]) / tt;
	}
	if (tt == 0.f) {
	    g1 = .5f;
	}
	g2 = 1.f - g1;
	res[i__] = (x[i__] - g1 * x[i__ - 1] - g2 * x[i__ + 1]) / sqrt(g1 * 
		g1 + 1.f + g2 * g2);
	*sigma2 += res[i__] * res[i__];
	sx = x[i__] * tt;
	ex += sx;
	ex2 += x[i__] * sx;
/* L1: */
    }
    tt = t[3] - t[2];
    if (tt != 0.f) {
	g1 = (t[1] - t[2]) / tt;
    }
    if (tt == 0.f) {
	g1 = .5f;
    }
    g2 = 1.f - g1;
    res[1] = (x[1] - g1 * x[3] - g2 * x[2]) / sqrt(g1 * g1 + 1.f + g2 * g2);
    tt = t[*n - 1] - t[*n - 2];
    if (tt != 0.f) {
	g1 = (t[*n - 1] - t[*n]) / tt;
    }
    if (tt == 0.f) {
	g1 = .5f;
    }
    g2 = 1.f - g1;
    res[*n] = (x[*n] - g1 * x[*n - 2] - g2 * x[*n - 1]) / sqrt(g1 * g1 + 1.f 
	    + g2 * g2);
    *sigma2 = (*sigma2 + res[1] * res[1] + res[*n] * res[*n]) / *n;
/* - */
    sx = x[*n] * (t[*n] - t[*n - 1]);
    dn = (t[*n] - t[1]) * 2.f;
    ex = (ex + sx) / dn;
    ex2 = (ex2 + x[*n] * sx) / dn;
    if (ex2 == 0.) {
	*snr = 0.f;
    }
    if (ex2 > 0.) {
	*snr = 1 - *sigma2 / (ex2 - ex * ex);
    }
    return 0;
} /* resest_ */

/* Subroutine */ int kernel_(doublereal *t, doublereal *x, integer *n, 
	doublereal *b, integer *nue, integer *kord, integer *ny, doublereal *
	s, doublereal *tt, integer *m, doublereal *y)
{
    /* System generated locals */
    real r__1, r__2;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
     doublereal chan;
    extern /* Subroutine */ int kernfa_(doublereal *, doublereal *, integer *,
	     doublereal *, integer *, integer *, integer *, doublereal *, 
	    doublereal *, integer *, doublereal *), kerncl_(doublereal *, 
	    doublereal *, integer *, doublereal *, integer *, integer *, 
	    integer *, doublereal *, doublereal *, integer *, doublereal *);

/* ----------------------------------------------------------------------- */
/*       SHORT-VERSION MAY, 1995 */

/*       DRIVER SUBROUTINE FOR KERNEL SMOOTHING, CHOOSES BETWEEN */
/*       STANDARD AND O(N) ALGORITHM */

/*  PARAMETERS : */

/*  INPUT    T(N)         INPUT GRID (REGRESSION DESIGN) */
/*  INPUT    X(N)         DATA, GIVEN ON T(N) */
/*  INPUT    N            LENGTH OF X */
/*  INPUT    B            ONE SIDED BANDWIDTH (FOR NY=1 MEAN BANDWIDTH) */
/*  INPUT    NUE          ORDER OF DERIVATIVE (0-4) */
/*  INPUT    KORD         ORDER OF KERNEL (<=6); DEFAULT IS KORD=NUE+2 */
/*  INPUT    NY           0: GLOBAL BANDWIDTH (DEFAULT) */
/*                        1: VARIABLE BANDWIDTHS, GIVEN IN Y AS INPUT */
/*  INPUT    S(0:N)       INTERPOLATION SEQUENCE */
/*  INPUT    TT(M)        OUTPUT GRID. MUST BE PART OF INPUT GRID FOR */
/*                        IEQ=0 */
/*  INPUT    M            NUMBER OF POINTS WHERE FUNCTION IS ESTIMATED, */
/*                         OR  LENGTH OF TT. DEFAULT IS M=400 */
/*  INPUT    Y(M)         BANDWITH SEQUENCE FOR NY=1, DUMMY FOR NY=0 */
/*  OUTPUT   Y(M)         ESTIMATED REGRESSION FUNCTION */

/* ----------------------------------------------------------------------- */
/* - */
/* ------  COMPUTING CHANGE POINT */
    /* Parameter adjustments */
    --x;
    --t;
    --y;
    --tt;

    /* Function Body */
/* Computing MAX */
    r__1 = 1.f, r__2 = sqrt((real) (*n) / (real) (*m));
    chan = (*kord + 5.f) * dmax(r__1,r__2);
/* ------ */
    if (*b * (*n - 1) / (t[*n] - t[1]) < chan) {
	kerncl_(&t[1], &x[1], n, b, nue, kord, ny, s, &tt[1], m, &y[1]);
    } else {
	kernfa_(&t[1], &x[1], n, b, nue, kord, ny, s, &tt[1], m, &y[1]);
    }
/* - */
    return 0;
} /* kernel_ */

/* Subroutine */ int kernfa_(doublereal *t, doublereal *x, integer *n, 
	doublereal *b, integer *nue, integer *kord, integer *ny, doublereal *
	s, doublereal *tt, integer *m, doublereal *y)
{
    /* System generated locals */
    integer i__1, i__2;
    doublereal d__1, d__2;

    /* Builtin functions */
    double pow_di(doublereal *, integer *);

    /* Local variables */
     doublereal a[49]	/* was [7][7] */, c__[7];
     integer i__, j, k;
     doublereal a1[7], a2[7], a3[49]	/* was [7][7] */;
     real s0;
     doublereal bb, cm[42]	/* was [7][6] */;
     integer jl, jr;
     doublereal xf[7];
     real sn;
     doublereal wr, sw[7];
     integer jnl;
     doublereal wid;
     integer jnr;
     doublereal wwl, wwr;
    extern /* Subroutine */ int dreg_(doublereal *, doublereal *, doublereal *
	    , integer *, doublereal *, doublereal *, doublereal *, doublereal 
	    *, doublereal *, integer *);
     doublereal dold;
    extern /* Subroutine */ int freg_(doublereal *, integer *, integer *, 
	    integer *, doublereal *, doublereal *, integer *, doublereal *);
     doublereal bmin, bmax;
    extern /* Subroutine */ int lreg_(doublereal *, doublereal *, integer *, 
	    doublereal *, doublereal *, doublereal *, doublereal *);
     integer iord;
     doublereal wido;
     integer init;
    extern /* Subroutine */ int coffb_(integer *, integer *, doublereal *, 
	    integer *, doublereal *);
     integer icall, iboun;

/* ----------------------------------------------------------------------- */
/*       SHORT-VERSION: MAY, 1995 */

/*       PURPOSE: */

/*       COMPUTATION OF KERNEL ESTIMATE USING O(N) ALGORITHM BASED ON */
/*       LEGENDRE POLYNOMIALS, GENERAL SPACED DESIGN AND LOCAL */
/*       BANDWIDTH ALLOWED. (NEW INITIALISATIONS OF THE LEGENDRE SUMS */
/*       FOR NUMERICAL REASONS) */

/*  PARAMETERS : */

/*  INPUT    T(N)         INPUT GRID */
/*  INPUT    X(N)         DATA, GIVEN ON T(N) */
/*  INPUT    N            LENGTH OF X */
/*  INPUT    B            ONE SIDED BANDWIDTH */
/*  INPUT    NUE          ORDER OF DERIVATIVE (0-4) */
/*  INPUT    KORD         ORDER OF KERNEL (<=6) */
/*  INPUT    NY           0, GLOBAL BANDWIDTH; 1, LOCAL BANDWIDTH IN Y */
/*  INPUT    S(0:N)       HALF POINT INTERPOLATION SEQUENCE */
/*  INPUT    TT(M)        OUTPUT GRID */
/*  INPUT    M            NUMBER OF POINTS TO ESTIMATE */
/*  INPUT    Y(M)         BANDWITH SEQUENCE FOR NY=1, DUMMY FOR NY=0 */
/*  OUTPUT   Y(M)         ESTIMATED FUNCTION */


/* ----------------------------------------------------------------------- */
/* - */
/* ------ COMPUTE CONSTANTS FOR LATER USE */
    /* Parameter adjustments */
    --x;
    --t;
    --y;
    --tt;

    /* Function Body */
    s0 = t[1] * 1.5f - t[2] * .5f;
    sn = t[*n] * 1.5f - t[*n - 1] * .5f;
    bmin = (sn - s0) * .6 / (doublereal) (*n) * (doublereal) (*kord - 1);
    bmax = (s[*n] - s[0]) * .5f;
    if (*kord == 2) {
	bmin *= .1;
    }
    iord = *kord + 1;
    i__1 = iord;
    for (k = 3; k <= i__1; ++k) {
	a1[k - 1] = (doublereal) ((k << 1) - 1) / (doublereal) k;
/* L2: */
	a2[k - 1] = (doublereal) (1 - k) / (doublereal) k;
    }
/* - */
    init = 0;
    icall = 0;
    dold = 0.;
/* - */
/* ------ SMOOTHING LOOP */
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
	bb = *b;
	if (*ny == 1) {
	    bb = y[i__];
	}
	if (bb < bmin) {
	    bb = bmin;
	}
	if (bb > bmax) {
	    bb = bmax;
	}
	iboun = 0;
/* - */
/* ------ COMPUTE LEFT BOUNDARY KERNEL */
	if (tt[i__] < s[0] + bb) {
	    wwl = s[0];
	    wwr = s[0] + bb + bb;
	    wid = wwr - tt[i__];
	    iboun = 1;
	    d__1 = (tt[i__] - s[0]) / wid;
	    coffb_(nue, kord, &d__1, &iboun, c__);
	}
/* - */
/* ------ COMPUTE RIGHT BOUNDARY KERNEL */
	if (tt[i__] + bb > s[*n]) {
	    wwl = s[*n] - (bb + bb);
	    wwr = s[*n];
	    wid = tt[i__] - wwl;
	    iboun = -1;
	    d__1 = (s[*n] - tt[i__]) / wid;
	    coffb_(nue, kord, &d__1, &iboun, c__);
	}
/* - */
/* ------ NO BOUNDARY */
	if (iboun == 0) {
	    wid = bb;
	    wwl = tt[i__] - bb;
	    wwr = tt[i__] + bb;
	}
/* - */
/* ------ INITIALISATION FOR INIT=0 */
	if (init == 0) {
	    i__2 = iord;
	    for (k = 1; k <= i__2; ++k) {
/* L44: */
		sw[k - 1] = 0.f;
	    }
	    jl = 1;
	    i__2 = *n;
	    for (j = 1; j <= i__2; ++j) {
		if (s[j - 1] < wwl) {
		    jl = j + 1;
		} else {
		    if (s[j] > wwr) {
			goto L488;
		    }
		    dreg_(sw, a1, a2, &iord, &x[j], &s[j - 1], &s[j], &tt[i__]
			    , &wid, &c__1);
		}
/* L48: */
	    }
L488:
	    jr = j - 1;
	    wr = wwr;
	    init = 1;
	    goto L6666;
	} else {
	    ++init;
	}
/* - */
/* ------ COMPARE OLD SUM WITH NEW SMOOTHING INTERVALL TT(I)-B,TT(I)+B */
	if (s[jr - 1] >= wwl) {
	    jnr = jr;
	    jnl = jl;
	    if (s[jr] > wwr) {
		i__2 = jl;
		for (j = jr; j >= i__2; --j) {
		    dreg_(sw, a1, a2, &iord, &x[j], &s[j - 1], &s[j], &tt[i__ 
			    - 1], &wido, &c_n1);
		    jnr = j - 1;
		    if (s[jnr] <= wwr) {
			goto L2011;
		    }
/* L201: */
		}
L2011:
		;
	    }
	    if (s[jl - 1] < wwl) {
		i__2 = jr;
		for (j = jl; j <= i__2; ++j) {
		    dreg_(sw, a1, a2, &iord, &x[j], &s[j - 1], &s[j], &tt[i__ 
			    - 1], &wido, &c_n1);
		    jnl = j + 1;
		    if (s[j] >= wwl) {
			goto L3011;
		    }
/* L301: */
		}
L3011:
		;
	    }
/* - */
/* ------ UPDATING OF SW */
	    d__1 = (tt[i__] - tt[i__ - 1]) / wid;
	    d__2 = wido / wid;
	    lreg_(sw, a3, &iord, &d__1, &dold, &d__2, cm);
	    if (jnr == jr) {
		i__2 = *n;
		for (j = jr + 1; j <= i__2; ++j) {
		    if (s[j] > wwr) {
			goto L4011;
		    }
		    dreg_(sw, a1, a2, &iord, &x[j], &s[j - 1], &s[j], &tt[i__]
			    , &wid, &c__1);
		    jnr = j;
/* L401: */
		}
L4011:
		;
	    }
	    jr = jnr;
	    if (jl == jnl) {
		for (j = jl - 1; j >= 1; --j) {
		    if (s[j - 1] < wwl) {
			goto L4022;
		    }
		    dreg_(sw, a1, a2, &iord, &x[j], &s[j - 1], &s[j], &tt[i__]
			    , &wid, &c__1);
		    jnl = j;
/* L402: */
		}
L4022:
		;
	    }
	    jl = jnl;
	} else {
/* - */
/* ------ NEW INITIALISATION OF SW */
	    i__2 = iord;
	    for (k = 1; k <= i__2; ++k) {
/* L22: */
		sw[k - 1] = 0.f;
	    }
	    i__2 = *n;
	    for (j = jr; j <= i__2; ++j) {
		if (s[j - 1] < wwl) {
		    jl = j + 1;
		} else {
		    if (s[j] > wwr) {
			goto L2022;
		    }
		    dreg_(sw, a1, a2, &iord, &x[j], &s[j - 1], &s[j], &tt[i__]
			    , &wid, &c__1);
		}
/* L202: */
	    }
L2022:
	    jr = j - 1;
	    wr = wwr;
	}
L6666:
/* - */
/* ------ IF BANDWIDTH IS TOO SMALL NO SMOOTHING */
	if (wwl >= s[jr - 1] && wwr <= s[jr]) {
	    y[i__] = x[jr];
	    if (*nue > 0) {
		y[i__] = 0.;
	    }
	} else {
/* - */
/* ------ ADD FIRST AND LAST POINT OF THE SMOOTHING INTERVAL */
	    i__2 = iord;
	    for (k = 1; k <= i__2; ++k) {
/* L501: */
		xf[k - 1] = sw[k - 1];
	    }
	    if (jl != 1) {
		dreg_(xf, a1, a2, &iord, &x[jl - 1], &wwl, &s[jl - 1], &tt[
			i__], &wid, &c__1);
	    }
	    if (jr != *n) {
		dreg_(xf, a1, a2, &iord, &x[jr + 1], &s[jr], &wwr, &tt[i__], &
			wid, &c__1);
	    }
/* - */
/* ------ NOW THE SUMS ARE BUILT THAT ARE NEEDED TO COMPUTE THE ESTIMATE */
	    freg_(xf, nue, kord, &iboun, &y[i__], c__, &icall, a);
	    if (*nue > 0) {
		y[i__] /= pow_di(&wid, nue);
	    }
	}
/* - */
/* ------ NEW INITIALISATION ? */
	if (jl > jr || wwl > wr || init > 100) {
	    init = 0;
	}
	wido = wid;
/* - */
/* L100: */
    }
/* - */
    return 0;
} /* kernfa_ */

/* Subroutine */ int dreg_(doublereal *sw, doublereal *a1, doublereal *a2, 
	integer *iord, doublereal *x, doublereal *sl, doublereal *sr, 
	doublereal *t, doublereal *b, integer *iflop)
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
     integer k;
     doublereal p[14]	/* was [7][2] */;

/* ----------------------------------------------------------------------- */
/*       VERSION: MAY, 1995 */

/*       PURPOSE: */

/*       COMPUTES NEW LEGENDRE SUMS (FOR REGRESSION) */

/*       PARAMETERS: */
/*                    **************   INPUT   ******************* */

/*        SW(IORD)  :   OLD SUM OF DATA WEIGHTS FOR LEGENDRE POLYNOM. */
/*        A1(7)     :   CONSTANTS OF RECURSIVE FORMULA FOR LEGENDRE POL. */
/*        A2(7)     :                             " */
/*        IORD      :   ORDER OF KERNEL POLYNOMIAL */
/*        X         :   DATA POINT */
/*        SL        :   LEFT S-VALUE */
/*        SR        :   RIGHT S-VALUE */
/*        T         :   POINT WHERE THE SMOOTHED VALUE IS TO BE ESTIMATED */
/*        B         :   BANDWIDTH */
/*        IFLOP     :   1: ADDITION, ELSE SUBTRACTION */


/*                    **************   OUTPUT   ******************* */

/*        SW(IORD)  :   NEW SUM OF DATA WEIGHTS FOR LEGENDRE POLYNOM. */

/* ----------------------------------------------------------------------- */
/* - */
/* ------  COMPUTE LEGENDRE POLYNOMIALS */
    /* Parameter adjustments */
    --a2;
    --a1;
    --sw;

    /* Function Body */
    p[0] = (*t - *sl) / *b;
    p[7] = (*t - *sr) / *b;
    p[1] = p[0] * 1.5 * p[0] - .5;
    p[8] = p[7] * 1.5 * p[7] - .5;
    i__1 = *iord;
    for (k = 3; k <= i__1; ++k) {
	p[k - 1] = a1[k] * p[k - 2] * p[0] + a2[k] * p[k - 3];
/* L1: */
	p[k + 6] = a1[k] * p[k + 5] * p[7] + a2[k] * p[k + 4];
    }
/* - */
/* ------  COMPUTE NEW LEGENDRE SUMS */
    if (*iflop == 1) {
	i__1 = *iord;
	for (k = 1; k <= i__1; ++k) {
/* L2: */
	    sw[k] += (p[k - 1] - p[k + 6]) * *x;
	}
    } else {
	i__1 = *iord;
	for (k = 1; k <= i__1; ++k) {
/* L3: */
	    sw[k] += (p[k + 6] - p[k - 1]) * *x;
	}
    }
    return 0;
} /* dreg_ */

/* Subroutine */ int lreg_(doublereal *sw, doublereal *a3, integer *iord, 
	doublereal *d__, doublereal *dold, doublereal *q, doublereal *c__)
{
    /* System generated locals */
    integer i__1, i__2;

    /* Local variables */
     integer i__, k, l;
     doublereal dd, qq, ww, xx;

/* ------------------------------------------------------------------ */
/*       VERSION: MAY, 1995 */

/*       PURPOSE: */

/*       UPDATE OF SW-SEQUENCE ACCORDING TO NEW BANDWIDTH AND NEW DATA */
/*       (VERSION FOR REGRESSION) */

/*       PARAMETERS : */
/*                          **************   INPUT   ******************* */

/*               SW(IORD)  :  SUM OF DATA WEIGHTS FOR LEGENDRE POLYNOM. */
/*               IORD      :  ORDER OF KERNEL POLYNOMIAL */
/*               D         :  DIST. TO THE NEXT POINT DIVIDED BY BANDW. */
/*               DOLD      :  D       PREVIOUS STEP */
/*               Q         :  NEW BANDWIDTH DIVIDED BY OLD BANDWIDTH */
/*                          **************    WORK   ******************* */

/*               A3(7,7)   :  MATRIX (P*Q*P)**(-1) */
/*               C(7,6)    :  MATRIX OF COEFFICIENTS */
/*                          **************   OUTPUT   ****************** */

/*               SW(IORD)  :  UPDATED VERSION OF SW */

/* --------------------------------------------------------------------- */
/* - */
/* - BUILD UP MATRIX */
    /* Parameter adjustments */
    c__ -= 8;
    a3 -= 8;
    --sw;

    /* Function Body */
    if (*dold != *d__ || *dold == 0.) {
	*dold = *d__;
	dd = *d__ * *d__;
/* - */
	if (*iord == 7) {
	    c__[49] = *d__ * 13.;
	    c__[42] = dd * 71.5;
	    c__[35] = (dd * 214.5 + 9.) * *d__;
	    c__[28] = (dd * 375.375 + 77.) * dd;
	    c__[21] = ((dd * 375.375 + 247.5) * dd + 5.) * *d__;
	    c__[14] = ((dd * 187.6875 + 346.5) * dd + 40.5) * dd;
	}
/* - */
	if (*iord >= 6) {
	    c__[41] = *d__ * 11.;
	    c__[34] = dd * 49.5;
	    c__[27] = (dd * 115.5 + 7.) * *d__;
	    c__[20] = (dd * 144.375 + 45.) * dd;
	    c__[13] = ((dd * 86.625 + 94.5) * dd + 3.) * *d__;
	}
/* - */
	if (*iord >= 5) {
	    c__[33] = *d__ * 9.;
	    c__[26] = dd * 31.5;
	    c__[19] = (dd * 52.5 + 5.) * *d__;
	    c__[12] = (dd * 39.375 + 21.) * dd;
	}
/* - */
	if (*iord >= 4) {
	    c__[25] = *d__ * 7.;
	    c__[18] = dd * 17.5;
	    c__[11] = (dd * 17.5 + 3.) * *d__;
	}
/* - */
	if (*iord >= 3) {
	    c__[17] = *d__ * 5.;
	    c__[10] = dd * 7.5;
	}
/* - */
	c__[9] = *d__ * 3.;
    }
    if (*q < .9999f || *q > 1.0001f) {
/* - */
/* ------- BUILT UP MATRIX A3=P*Q*P**-1 */
	a3[8] = *q;
	i__1 = *iord;
	for (k = 2; k <= i__1; ++k) {
/* L1: */
	    a3[k + k * 7] = a3[k - 1 + (k - 1) * 7] * *q;
	}
	ww = *q * *q - 1.;
	i__1 = *iord - 2;
	for (k = 1; k <= i__1; ++k) {
	    ww *= *q;
/* L2: */
	    a3[k + 2 + k * 7] = (k + .5) * ww;
	}
/* - */
	if (*iord >= 5) {
	    qq = a3[16];
	    a3[12] = *q * (qq * (qq * 3.375 - 5.25) + 1.875);
	}
	if (*iord >= 6) {
	    a3[20] = qq * (qq * (qq * 6.875 - 11.25) + 4.375);
	}
	if (*iord == 7) {
	    a3[14] = *q * (qq * (qq * (qq * 8.9375 - 18.5625) + 11.8125) - 
		    2.1875);
	    a3[28] = *q * qq * (qq * (qq * 11.375 - 19.25) + 7.875);
	}
/* - */
/* ------- COMPUTE A*C AND NEW LEGENDRE SUMS */
	for (i__ = *iord; i__ >= 2; --i__) {
	    xx = 0.f;
	    i__1 = i__;
	    for (k = 1; k <= i__1; ++k) {
		ww = 0.f;
		i__2 = i__ - 1;
		for (l = k; l <= i__2; l += 2) {
/* L30: */
		    ww += a3[l + k * 7] * c__[i__ + l * 7];
		}
		if ((i__ - k) % 2 == 0) {
		    ww += a3[i__ + k * 7];
		}
		xx += ww * sw[k];
/* L20: */
	    }
	    sw[i__] = xx;
/* L10: */
	}
	sw[1] = a3[8] * sw[1];
    } else {
	for (i__ = *iord; i__ >= 2; --i__) {
	    i__1 = i__ - 1;
	    for (k = 1; k <= i__1; ++k) {
/* L112: */
		sw[i__] += c__[i__ + k * 7] * sw[k];
	    }
/* L111: */
	}
    }
    return 0;
} /* lreg_ */

/* Subroutine */ int freg_(doublereal *sw, integer *nue, integer *kord, 
	integer *iboun, doublereal *y, doublereal *c__, integer *icall, 
	doublereal *a)
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
     integer i__, j;
     doublereal ww;

/* ------------------------------------------------------------------ */
/*       SHORT-VERSION: MAY, 1995 */

/*       PURPOSE: */

/*       FINAL COMPUTATION OF A SMOOTHED VALUE VIA LEGENDRE POLYNOMIALS */

/*       PARAMETERS : */
/*                          **************   INPUT   ******************* */

/*               SW(KORD+1):  SUM OF DATA WEIGHTS FOR LEGENDRE POLYNOM. */
/*               NUE       :  ORDER OF DERIVATIVE */
/*               KORD      :  ORDER OF KERNEL */
/*               IBOUN     :  0: INTERIOR KERNEL, ELSE BOUNDARY KERNEL */
/*               C(KORD+1) :  SEQUENCE OF POLYN. COEFF. FOR BOUND. KERNEL */
/*               ICALL     :  PARAMETER USED TO INITIALISE COMPUTATION */
/*                         :   OF A MATRIX */
/*                          **************    WORK    ****************** */

/*               A(7,7)    :  MATRIX OF COEFFICIENTS */
/*                          **************   OUTPUT   ****************** */

/*               Y          :  COMPUTED ESTIMATE */

/* -------------------------------------------------------------------- */
/* - */
/* ------- DEFINITION OF LEGENDRE COEFFICIENTS FOR BOUNDARY */
    /* Parameter adjustments */
    a -= 8;
    --c__;
    --sw;

    /* Function Body */
    if (*icall == 0 && *iboun != 0) {
	a[16] = .66666666666666663f;
	a[22] = .6f;
	a[24] = .4f;
	a[30] = .5714285714285714f;
	a[32] = .22857142857142856f;
	a[36] = .42857142857142855f;
	a[38] = .44444444444444442f;
	a[40] = .12698412698412698f;
	a[44] = .47619047619047616f;
	a[46] = .31168831168831168f;
	a[48] = .069264069264069264f;
	a[50] = .33333333333333331f;
	a[52] = .42424242424242425f;
	a[54] = .20512820512820512f;
	a[56] = .037296037296037296f;
	*icall = 1;
    }
    if (*iboun != 0) {
/* - */
/* ------- COMPUTATION OF THE SMOOTHED VALUE AT BOUNDARY */
	*y = c__[1] * sw[1] + c__[2] * a[16] * sw[2];
	i__1 = *kord + 1;
	for (j = 3; j <= i__1; ++j) {
	    ww = a[j + j * 7] * sw[j];
	    for (i__ = j - 2; i__ >= 1; i__ += -2) {
/* L2: */
		ww += a[i__ + j * 7] * sw[i__];
	    }
	    *y += c__[j] * ww;
/* L1: */
	}
    } else {
/* - */
/* ------- COMPUTATION OF THE SMOOTHED VALUE AT INTERIOR */
	if (*nue == 0) {
	    if (*kord == 2) {
		*y = sw[3] * -.1f + sw[1] * .6f;
	    }
	    if (*kord == 4) {
		*y = (sw[5] - sw[3] * 4.f + sw[1] * 9.f) / 12.f;
	    }
	    if (*kord == 6) {
		*y = sw[7] * -.072115379f + sw[5] * .25961537f - sw[3] * 
			.4375f + sw[1] * .75f;
	    }
	}
	if (*nue == 1) {
	    if (*kord == 3) {
		*y = (sw[4] * 3.f - sw[2] * 10.f) / 14.f;
	    }
	    if (*kord == 5) {
		*y = (sw[6] * -15.f + sw[4] * 48.f - sw[2] * 55.f) / 44.f;
	    }
	}
	if (*nue == 2) {
	    if (*kord == 4) {
		*y = (sw[5] * -5.f + sw[3] * 14.f - sw[1] * 9.f) / 6.f;
	    }
	    if (*kord == 6) {
		*y = sw[7] * 2.01923f - sw[5] * 5.76923f + sw[3] * 5.25f - sw[
			1] * 1.5f;
	    }
	}
	if (*nue == 3) {
	    *y = sw[6] * 4.772727f - sw[4] * 12.272727f + sw[2] * 7.5f;
	}
	if (*nue == 4) {
	    *y = sw[7] * -36.34615f + sw[5] * 88.84615f - sw[3] * 52.5f;
	}
    }
/* - */
    return 0;
} /* freg_ */

/* Subroutine */ int kerncl_(doublereal *t, doublereal *x, integer *n, 
	doublereal *b, integer *nue, integer *kord, integer *ny, doublereal *
	s, doublereal *tt, integer *m, doublereal *y)
{
    /* System generated locals */
    integer i__1;
    doublereal d__1;

    /* Local variables */
     doublereal c__[7];
     integer i__;
     doublereal c1[7];
     real s0;
     doublereal s1, bb;
     real sn;
     doublereal wid;
    extern /* Subroutine */ int smo_(doublereal *, doublereal *, integer *, 
	    doublereal *, doublereal *, integer *, integer *, integer *, 
	    integer *, doublereal *, doublereal *, doublereal *);
     integer ist;
     doublereal bmin, bmax;
     integer iord;
    extern /* Subroutine */ int coffb_(integer *, integer *, doublereal *, 
	    integer *, doublereal *), coffi_(integer *, integer *, doublereal 
	    *);
     integer iboun;

/* ----------------------------------------------------------------------- */
/*       SHORT-VERSION JANUARY 1995 */

/*       KERNEL SMOOTHING, CONVENTIONAL ALGORITHM,GENERAL */
/*       DESIGN, LOCAL BANDWIDTH ALLOWED */

/*  PARAMETERS : */

/*  INPUT    T(N)         INPUT GRID */
/*  INPUT    X(N)         DATA, GIVEN ON T(N) */
/*  INPUT    N            LENGTH OF X */
/*  INPUT    B            ONE SIDED BANDWIDTH (FOR NY=1 MEAN BANDWIDTH) */
/*  INPUT    NUE          ORDER OF DERIVATIVE (0-4) */
/*  INPUT    KORD         ORDER OF KERNEL (<=6) */
/*  INPUT    S(0:N)       HALF POINT INTERPOLATION SEQUENCE */
/*  INPUT    NY           0: GLOBAL, 1: LOCAL BANDWIDTH INPUTED IN Y */
/*  INPUT    TT(M)        OUTPUT GRID */
/*  INPUT    M            NUMBER OF POINTS TO ESTIMATE */
/*  INPUT    Y(M)         BANDWITH SEQUENCE FOR NY=1, DUMMY FOR NY=0 */
/*  OUTPUT   Y(M)         ESTIMATED REGRESSION FUNCTION */

/* ----------------------------------------------------------------------- */
/* - */
/* ------  COMPUTE KERNEL COEFFICIENTS FOR INTERIOR AND SOME CONSTANTS */
    /* Parameter adjustments */
    --x;
    --t;
    --y;
    --tt;

    /* Function Body */
    coffi_(nue, kord, c__);
    iord = *kord + 1;
    bb = *b;
    s0 = t[1] * 1.5f - t[2] * .5f;
    sn = t[*n] * 1.5f - t[*n - 1] * .5f;
    bmin = (sn - s0) * .6 / (doublereal) (*n) * (doublereal) (*kord - 1);
    bmax = (s[*n] - s[0]) * .5f;
    if (*kord == 2) {
	bmin *= .1;
    }
    ist = 1;
/* - */
/* -------  LOOP OVER OUTPUT GRID */
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (*ny != 0) {
	    bb = y[i__];
	}
	if (bb > bmax) {
	    bb = bmax;
	}
	if (bb < bmin) {
	    bb = bmin;
	}
	wid = bb;
	s1 = tt[i__] - bb;
	iboun = 0;
/* - */
/* -------  COMPUTE LEFT BOUNDARY KERNEL */
	if (s1 < s[0]) {
	    s1 = s[0];
	    wid = bb + bb + s[0] - tt[i__];
	    d__1 = (tt[i__] - s[0]) / wid;
	    coffb_(nue, kord, &d__1, &c__1, c1);
	    iboun = 1;
	}
/* - */
/* -------  COMPUTE RIGHT BOUNDARY KERNEL */
	if (tt[i__] + bb > s[*n]) {
	    s1 = s[*n] - (bb + bb);
	    wid = tt[i__] - s1;
	    d__1 = (s[*n] - tt[i__]) / wid;
	    coffb_(nue, kord, &d__1, &c_n1, c1);
	    iboun = -1;
	}
/* - */
/* ------  SEARCH FIRST S-POINT OF SMOOTHING INTERVAL */
L2:
	if (s[ist] <= s1) {
	    ++ist;
	    goto L2;
	}
L3:
	if (s[ist - 1] > s1) {
	    --ist;
	    goto L3;
	}
/* - */
/* -------  IF BANDWIDTH IS TOO SMALL NO SMOOTHING */
	if (s[ist] >= tt[i__] + wid || ist == *n) {
	    y[i__] = x[ist];
	    if (*nue > 0) {
		y[i__] = 0.f;
	    }
	} else {
/* - */
/* -----  COMPUTE SMOOTHED DATA AT TT(I) */
	    if (iboun != 0) {
		smo_(s, &x[1], n, &tt[i__], &wid, nue, &iord, &iboun, &ist, &
			s1, c1, &y[i__]);
	    } else {
		smo_(s, &x[1], n, &tt[i__], &wid, nue, &iord, &iboun, &ist, &
			s1, c__, &y[i__]);
	    }
	}
/* L100: */
    }
/* - */
    return 0;
} /* kerncl_ */

/* Subroutine */ int smo_(doublereal *s, doublereal *x, integer *n, 
	doublereal *tau, doublereal *wid, integer *nue, integer *iord, 
	integer *iboun, integer *ist, doublereal *s1, doublereal *c__, 
	doublereal *y)
{
    /* System generated locals */
    integer i__1, i__2, i__3;

    /* Builtin functions */
    double pow_di(doublereal *, integer *);

    /* Local variables */
     integer i__, j;
     doublereal w, wo[7], yy, yyy;
     integer ibeg, jend, incr;
     doublereal widnue;

/* ----------------------------------------------------------------------- */
/*       SHORT-VERSION JANUARY 1995 */

/*       PERFORMS ONE SMOOTHING STEP */

/*  PARAMETERS : */

/*  INPUT    S(0:N)       HALF POINT INTERPOLATION SEQUENCE */
/*  INPUT    X(N)         DATA */
/*  INPUT    N            LENGTH OF X */
/*  INPUT    TAU          POINT WHERE FUNCTION IS ESTIMATED */
/*  INPUT    WID          ONE SIDED BANDWIDTH */
/*  INPUT    NUE          ORDER OF DERIVATIVE (0-4) */
/*  INPUT    IORD          ORDER OF KERNEL POLYNOMIAL */
/*  INPUT    IBOUN         TYPE OF BOUNDARY */
/*  INPUT    IST          INDEX OF FIRST POINT OF SMOOTHING INTERVAL */
/*  INPUT    S1           LEFT BOUNDARY OF SMOOTHING INTERVAL */
/*  INPUT    C(7)         KERNEL COEFFICIENTS */
/*  OUTPUT   Y            SMOOTHED VALUE AT TAU */
/*  WORK     WO(7)        WORK ARRAY */

/* ----------------------------------------------------------------------- */
/* - */
    /* Parameter adjustments */
    --x;
    --c__;

    /* Function Body */
    *y = 0.f;
    jend = 0;
    ibeg = 2;
    if (*iboun != 0 || *nue != 1 && *nue != 3) {
	ibeg = 1;
    }
    incr = 2;
    if (*iboun != 0) {
	incr = 1;
    }
/* - */
/* ------  COMPUTE INITIAL KERNEL VALUES */
    if (*iboun > 0) {
	yy = (*tau - *s1) / *wid;
	wo[ibeg - 1] = yy;
	i__1 = *iord - incr;
	i__2 = incr;
	for (i__ = ibeg; i__2 < 0 ? i__ >= i__1 : i__ <= i__1; i__ += i__2) {
/* L1: */
	    wo[i__ + incr - 1] = wo[i__ - 1] * yy;
	}
    } else {
	i__2 = *iord;
	i__1 = incr;
	for (i__ = ibeg; i__1 < 0 ? i__ >= i__2 : i__ <= i__2; i__ += i__1) {
/* L2: */
	    wo[i__ - 1] = 1.f;
	}
    }
/* - */
/* ------  LOOP OVER SMOOTHING INTERVAL */
    i__1 = *n;
    for (j = *ist; j <= i__1; ++j) {
	yy = (*tau - s[j]) / *wid;
	if (yy < -1.f) {
	    yy = -1.f;
	    jend = 1;
	}
	yyy = yy;
	if (*iboun == 0) {
	    yy *= yy;
	    if (*nue == 1 || *nue == 3) {
		yyy = yy;
	    }
	}
/* - */
/* ------  LOOP FOR COMPUTING WEIGHTS */
	w = 0.f;
	i__2 = *iord;
	i__3 = incr;
	for (i__ = ibeg; i__3 < 0 ? i__ >= i__2 : i__ <= i__2; i__ += i__3) {
	    w += c__[i__] * (wo[i__ - 1] - yyy);
	    wo[i__ - 1] = yyy;
	    yyy *= yy;
/* L3: */
	}
	*y += w * x[j];
	if (jend == 1) {
	    goto L110;
	}
/* L100: */
    }
/* - */
/* -------  NORMALIZING FOR NUE>0 */
L110:
    if (*nue > 0) {
	widnue = pow_di(wid, nue);
	*y /= widnue;
    }
/* - */
    return 0;
} /* smo_ */

/* Subroutine */ int coffi_(integer *nue, integer *kord, doublereal *c__)
{
     integer i__;

/* ----------------------------------------------------------------------- */
/*       SHORT-VERSION: JANUARY 1995 */

/*       PURPOSE: */

/*       DEFINES POLYNOMIAL KERNEL COEFFICIENTS FOR INTERIOR. */

/*  PARAMETERS: */

/*  INPUT  NUE        ORDER OF DERIVATIVE (0-4) */
/*  INPUT  KORD       ORDER OF KERNEL (NUE+I, I=2,4,6;  KORD<=6) */
/*  OUTPUT C(7)       POLYNOMIAL KERNEL COEFFICIENTS */

/* ----------------------------------------------------------------------- */
/* - */
    /* Parameter adjustments */
    --c__;

    /* Function Body */
    for (i__ = 1; i__ <= 7; ++i__) {
/* L10: */
	c__[i__] = 0.f;
    }
    if (*nue == 0 && *kord == 2) {
	c__[1] = .75;
	c__[3] = -.25;
    }

    if (*nue == 0 && *kord == 4) {
	c__[1] = 1.40625;
	c__[3] = -1.5625;
	c__[5] = .65625;
    }

    if (*nue == 0 && *kord == 6) {
	c__[1] = 2.05078125;
	c__[3] = -4.78515625;
	c__[5] = 5.16796875;
	c__[7] = -1.93359375;
    }

    if (*nue == 1 && *kord == 3) {
	c__[2] = -1.875;
	c__[4] = .9375;
    }

    if (*nue == 1 && *kord == 5) {
	c__[2] = -8.203125;
	c__[4] = 11.484375;
	c__[6] = -4.921875;
    }

    if (*nue == 2 && *kord == 4) {
	c__[1] = -6.5625;
	c__[3] = 13.125;
	c__[5] = -6.5625;
    }

    if (*nue == 2 && *kord == 6) {
	c__[1] = -24.609375;
	c__[3] = 103.359375;
	c__[5] = -132.890625;
	c__[7] = 54.140625;
    }

    if (*nue == 3 && *kord == 5) {
	c__[2] = 88.59375;
	c__[4] = -147.65625;
	c__[6] = 68.90625;
    }

    if (*nue == 4 && *kord == 6) {
	c__[1] = 324.84375;
	c__[3] = -1624.21875;
	c__[5] = 2273.90625;
	c__[7] = -974.53125;
    }

    return 0;
} /* coffi_ */

/* Subroutine */ int coffb_(integer *nue, integer *kord, doublereal *q, 
	integer *iboun, doublereal *c__)
{
    /* System generated locals */
    integer i__1;
    doublereal d__1;

    /* Local variables */
     doublereal d__;
     integer i__, j;
     doublereal p, p1, p3, p6, p12;

/* ----------------------------------------------------------------------- */
/*       SHORT-VERSION: JANUARY 1995 */

/*       PURPOSE: */

/*       COMPUTES COEFFICIENTS OF POLYNOMIAL BOUNDARY KERNELS, */
/*       FOLLOWING GASSER + MUELLER PREPRINT 38 SFB 123 HEIDELBERG */
/*       AND UNPUBLISHED RESULTS */

/*  PARAMETERS: */

/*  INPUT  NUE        ORDER OF DERIVATIVE (0-4) */
/*  INPUT  KORD       ORDER OF KERNEL (NUE+I, I=2,4,6;  KORD<=6) */
/*  INPUT  Q          PERCENTAGE OF WID AT BOUNDARY */
/*  INPUT  IBOUN      < 0 RIGHT BOUNDARY OF DATA */
/*                    > 0 LEFT BOUNDARY OF DATA */
/*  OUTPUT C(7)       POLYNOMIAL KERNEL COEFFICIENTS */

/* ----------------------------------------------------------------------- */

    /* Parameter adjustments */
    --c__;

    /* Function Body */
    for (i__ = 1; i__ <= 7; ++i__) {
/* L10: */
	c__[i__] = 0.f;
    }
    p = -(*q);
    p1 = *q + 1.f;
    p3 = p1 * p1 * p1;

    if (*nue == 0 && *kord == 2) {
	d__ = 1.f / (p3 * p1);
	c__[1] = (p * (p * 18.f + 12.f) + 6.f) * d__;
	c__[2] = (p + 1.f) * 9.f * (p + 1.f) * d__;
	c__[3] = (p * 8.f + 4.f) * d__;
    }

    if (*nue == 0 && *kord == 4) {
	d__ = p1 / (p3 * p3 * p3);
	p12 = (p + 1.f) * (p + 1.f) * d__;
	c__[1] = (p * (p * (p * (p * (p * (p * 10.f + 60.f) + 165.f) + 164.f) 
		+ 78.f) + 12.f) + 1.f) * 20.f * d__;
/* Computing 2nd power */
	d__1 = p * (p + 5.f) + 1.f;
	c__[2] = d__1 * d__1 * 100.f * p12;
	c__[3] = (p * (p * (p * (p * (p + 14.f + p) + 36.f) + 33.f) + 12.f) + 
		1.f) * 200.f * d__;
	c__[4] = (p * (p * 3.f + 10.f) + 1.f) * 175.f * p12;
	c__[5] = (p * (p * (p * 4.f + 18.f) + 12.f) + 1.f) * 56.f * d__;
    }

    if (*nue == 0 && *kord == 6) {
	p6 = p3 * p3;
	d__ = 1.f / (p6 * p6);
	p12 = (p + 1.f) * (p + 1.f) * d__;
	c__[1] = (p * (p * (p * (p * (p * (p * (p * (p * (p * (p * 21.f + 
		350.f) + 2625.f) + 9240.f) + 17430.f) + 17772.f) + 10050.f) + 
		3e3f) + 465.f) + 30.f) + 1.f) * 42.f * d__;
/* Computing 2nd power */
	d__1 = p * (p * (p * (p + 14.f) + 36.f) + 14.f) + 1.f;
	c__[2] = d__1 * d__1 * 441.f * p12;
	c__[3] = (p * (p * (p * (p * (p * (p * (p * (p * (p + 39.f + p) + 
		300.f) + 1065.f) + 1956.f) + 1902.f) + 984.f) + 255.f) + 30.f)
		 + 1.f) * 1960.f * d__;
	c__[4] = (p * (p * (p * (p * (p * (p * 3.f + 42.f) + 188.f) + 308.f) 
		+ 156.f) + 28.f) + 1.f) * 4410.f * p12;
	c__[5] = (p * (p * (p * (p * (p * (p * (p * 4.f + 57.f) + 250.f) + 
		485.f) + 440.f) + 185.f) + 30.f) + 1.f) * 5292.f * d__;
	c__[6] = (p * (p * (p * (p * 5.f + 56.f) + 108.f) + 28.f) + 1.f) * 
		3234.f * p12;
	c__[7] = (p * (p * (p * (p * (p * 6.f + 75.f) + 200.f) + 150.f) + 
		30.f) + 1.f) * 792.f * d__;
    }

    if (*nue == 1 && *kord == 3) {
	d__ = -1.f / (p3 * p3);
	p12 = (p + 1.f) * (p + 1.f) * d__;
	c__[1] = (p * 240.f + 60.f) * p12;
	c__[2] = (p * (p * (p + 6.f) + 6.f) + 2.f) * 120.f * d__;
	c__[3] = p12 * 300.f;
	c__[4] = (p * 180.f + 120.f) * d__;
    }

    if (*nue == 1 && *kord == 5) {
	d__ = -1.f / (p3 * p3 * p3 * p1);
	p12 = (p + 1.f) * (p + 1.f) * d__;
	c__[1] = (p * (p * (p * (p * (p * 10.f + 75.f) + 176.f) + 98.f) + 
		18.f) + 1.f) * 420.f * p12;
	c__[2] = (p * (p * (p * (p * (p * (p * (p + 20.f) + 105.f) + 238.f) + 
		245.f) + 120.f) + 25.f) + 2.f) * 2100.f * d__;
/* Computing 2nd power */
	d__1 = p * (p + 4.f) + 1.f;
	c__[3] = d__1 * d__1 * 14700.f * p12;
	c__[4] = (p * (p * (p * (p * (p * 6.f + 40.f) + 95.f) + 90.f) + 35.f) 
		+ 4.f) * 5880.f * d__;
	c__[5] = (p * (p + 6.f + p) + 1.f) * 17640.f * p12;
	c__[6] = (p * (p * (p * 5.f + 20.f) + 15.f) + 2.f) * 2520.f * d__;
    }

    if (*nue == 2 && *kord == 4) {
	d__ = p1 / (p3 * p3 * p3);
	p12 = (p + 1.f) * (p + 1.f) * d__;
	c__[1] = (p * (p * (p * (p * 5.f + 24.f) + 28.f) + 12.f) + 1.f) * 
		840.f * d__;
	c__[2] = (p * (p + 10.f) + 3.f) * 2100.f * p12;
	c__[3] = (p * (p * (p * 6.f + 27.f) + 28.f) + 9.f) * 1680.f * d__;
	c__[4] = p12 * 14700.f;
	c__[5] = (p * 6720.f + 5040.f) * d__;
    }

    if (*nue == 2 && *kord == 6) {
	p6 = p3 * p3;
	d__ = 1.f / (p6 * p6);
	p12 = (p + 1.f) * (p + 1.f) * d__;
	c__[1] = (p * (p * (p * (p * (p * (p * (p * (p * 21.f + 294.f) + 
		1365.f) + 2952.f) + 3195.f) + 1786.f) + 489.f) + 60.f) + 2.f) 
		* 5040.f * d__;
	c__[2] = (p * (p * (p * (p * (p * (p + 28.f) + 156.f) + 308.f) + 
		188.f) + 42.f) + 3.f) * 52920.f * p12;
	c__[3] = (p * (p * (p * (p * (p * (p * (p * 4.f + 57.f) + 264.f) + 
		555.f) + 570.f) + 291.f) + 68.f) + 6.f) * 141120.f * d__;
/* Computing 2nd power */
	d__1 = p * (p + 7.f + p) + 2.f;
	c__[4] = d__1 * d__1 * 529200.f * p12;
	c__[5] = (p * (p * (p * (p * (p * 40.f + 255.f) + 582.f) + 559.f) + 
		228.f) + 30.f) * 90720.f * d__;
	c__[6] = (p * (p * 5.f + 14.f) + 3.f) * 582120.f * p12;
	c__[7] = (p * (p * (p * 4.f + 15.f) + 12.f) + 2.f) * 221760.f * d__;
    }

    if (*nue == 3 && *kord == 5) {
	d__ = -1.f / (p3 * p3 * p3 * p1);
	p12 = (p + 1.f) * (p + 1.f) * d__;
	c__[1] = (p * (p * (p * 6.f + 38.f) + 18.f) + 1.f) * 15120.f * p12;
	c__[2] = (p * (p * (p * (p * (p + 20.f) + 70.f) + 80.f) + 35.f) + 4.f)
		 * 45360.f * d__;
	c__[3] = (p * (p + 6.f) + 2.f) * 352800.f * p12;
	c__[4] = (p * (p * (p * 6.f + 24.f) + 25.f) + 8.f) * 151200.f * d__;
	c__[5] = p12 * 952560.f;
	c__[6] = (p * 5.f + 4.f) * 70560.f * d__;
    }

    if (*nue == 4 && *kord == 6) {
	p6 = p3 * p3;
	d__ = 1.f / (p6 * p6);
	p12 = (p + 1.f) * (p + 1.f) * d__;
	c__[1] = (p * (p * (p * (p * (p * (p * 7.f + 90.f) + 285.f) + 340.f) 
		+ 171.f) + 30.f) + 1.f) * 332640.f * d__;
	c__[2] = (p * (p * (p * (p + 28.f) + 108.f) + 56.f) + 5.f) * 
		1164240.f * p12;
	c__[3] = (p * (p * (p * (p * (p + 25.f + p) + 76.f) + 85.f) + 38.f) + 
		5.f) * 6652800.f * d__;
	c__[4] = (p * (p * 3.f + 14.f) + 5.f) * 17463600.f * p12;
	c__[5] = (p * (p * (p * 20.f + 75.f) + 78.f) + 25.f) * 4656960.f * 
		d__;
	c__[6] = p12 * 76839840.f;
	c__[7] = (p * 6.f + 5.f) * 3991680.f * d__;
    }

    if (*iboun > 0) {
	return 0;
    }
    j = 2;
    if (*nue == 1 || *nue == 3) {
	j = 1;
    }
    i__1 = *kord;
    for (i__ = j; i__ <= i__1; i__ += 2) {
/* L2: */
	c__[i__] = -c__[i__];
    }
    return 0;
} /* coffb_ */

/* Subroutine */ int coff_(doublereal *x, integer *n, doublereal *fa)
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
     integer i__;

    /* Parameter adjustments */
    --x;

    /* Function Body */
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* L1: */
	x[i__] = *fa;
    }
    return 0;
} /* coff_ */

